#!/bin/bash

##########functions definition########################
# needs to be run within the docker container of squadproject/squad-report:1.2.0
# which has the build-email and send-mail command installed by default
function send_mail_common(){
    local f_email_body="${1}"
    local email_subject="${2}"

    build-email \
        --msg-from=${REVIEW_FROM} \
        --msg-to=${REVIEW_TO} \
        --msg-cc=${REVIEW_CC} \
        --msg-body=${f_email_body} \
        --msg-subject="${email_subject}" \
        "--msg-body-pre=Go here to check the pipeline jobs: ${CI_PIPELINE_URL}." >mail.txt

    send-email mail.txt
}

function get_kernel_version(){
    if [ -f Makefile ]; then
        # parse the Makefile directory
        # KERNELVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
        head -n5 Makefile |sed 's| =|=|' | sed 's|= |=|' >kernel-makefile.tmp
        kernel_version=$(source kernel-makefile.tmp; echo ${VERSION}${PATCHLEVEL:+.${PATCHLEVEL}${SUBLEVEL:+.${SUBLEVEL}}}${EXTRAVERSION})
    elif [ -f "${F_KERNEL_INFO}" ]; then
        # this file is generated by the new_changes_notification job
        kernel_version=$(jq -r '.MAKE_KERNELVERSION' "${F_KERNEL_INFO}")
    else
        f_build_info=""
        if [ -n "${ANDROID_BUILD_CONFIG}" ] && [ -f "${ANDROID_BUILD_CONFIG}-build.json" ]; then
            f_build_info="${ANDROID_BUILD_CONFIG}-build.json"
        elif [ -n "${KERNEL_BUILD_CONFIG}" ] && [ -f "${KERNEL_BUILD_CONFIG}-build.json" ]; then
            f_build_info="${KERNEL_BUILD_CONFIG}-build.json"
        fi
        if [ -f "${f_build_info}" ]; then
            if grep -q -s MAKE_KERNELVERSION "${f_build_info}"; then
                # file that from the jenkins build
                kernel_version=$(jq .MAKE_KERNELVERSION "${f_build_info}" |tr -d \")
            elif grep -q -s kernel_version "${f_build_info}"; then
                # file that generated by the tuxsuite service
                kernel_version=$(jq -r '.[] | .kernel_version' ${f_build_info})
            fi
        fi
    fi

    if [ -z "${kernel_version}" ]; then
        kernel_version="unkonwn"
    fi
    echo "${kernel_version}"
}
######### functions definiton end here ####################################